import { ElementRef, Injector, Type } from '@angular/core';
export declare class AngularRenderer<C> {
    private applicationRef;
    private componentRef;
    constructor(component: Type<C>, injector: Injector);
    get instance(): C;
    get elementRef(): ElementRef;
    get dom(): HTMLElement;
    detectChanges(): void;
    destroy(): void;
}
