import { ElementRef, OnDestroy, OnInit, Renderer2 } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { Content, Editor } from '@tiptap/core';
import * as i0 from "@angular/core";
export declare class EditorDirective implements OnInit, ControlValueAccessor, OnDestroy {
    private el;
    private _renderer;
    editor: Editor;
    outputFormat: 'json' | 'html';
    constructor(el: ElementRef<HTMLElement>, _renderer: Renderer2);
    private onChange;
    private onTouched;
    writeValue(value: Content): void;
    registerOnChange(fn: () => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    private handleChange;
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EditorDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<EditorDirective, "tiptap[editor], [tiptap][editor], tiptap-editor[editor], [tiptapEditor][editor]", never, { "editor": "editor"; "outputFormat": "outputFormat"; }, {}, never>;
}
