import { Injector, Type } from '@angular/core';
import { NodeViewProps, NodeViewRenderer } from '@tiptap/core';
import type { Decoration } from 'prosemirror-view';
import type { Node as ProseMirrorNode } from 'prosemirror-model';
import * as i0 from "@angular/core";
export declare class AngularNodeViewComponent {
    props: NodeViewProps;
    static ɵfac: i0.ɵɵFactoryDeclaration<AngularNodeViewComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AngularNodeViewComponent, "ng-component", never, { "props": "props"; }, {}, never, never>;
}
interface AngularNodeViewRendererOptions {
    stopEvent?: ((event: Event) => boolean) | null;
    update?: ((node: ProseMirrorNode, decorations: Decoration[]) => boolean) | null;
    injector: Injector;
}
export declare const AngularNodeViewRenderer: (component: Type<AngularNodeViewComponent>, options: AngularNodeViewRendererOptions) => NodeViewRenderer;
export {};
